# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/02_grds.ipynb.

# %% auto 0
__all__ = ['iscatidx', 'isboolidx', 'isidxlike']

# %% ../nbs/02_grds.ipynb 6
import string
from inspect import signature as getsig, getfullargspec as getspec
from itertools import islice, cycle

# %% ../nbs/02_grds.ipynb 8
from typing import TypeGuard

# %% ../nbs/02_grds.ipynb 11
#| export

# %% ../nbs/02_grds.ipynb 13
try: import numpy as np, pandas as pd
except ImportError: ...

# %% ../nbs/02_grds.ipynb 15
#| export


# %% ../nbs/02_grds.ipynb 17
#| export


# %% ../nbs/02_grds.ipynb 19
from atyp import (CatIndex, IndexLike, IndexQ, BoolIndex, IterBool)
from chck import notnone

# %% ../nbs/02_grds.ipynb 21
#| export


# %% ../nbs/02_grds.ipynb 23
def iscatidx(idx) -> TypeGuard[CatIndex]:
    '''Check if `idx` is a `pd.CategoricalIndex`'''
    return isinstance(idx, pd.CategoricalIndex)

def isboolidx(idx: IterBool, other: IndexQ = None) -> TypeGuard[BoolIndex]:
    '''Check if `idx` is a `pd.Index` of booleans'''
    return isinstance(idx, BoolIndex) and (len(idx) == len(other) if notnone(other) else True)

def isidxlike(a) -> TypeGuard[IndexLike]:
    '''Check if `idx` is similar to a `pd.Index`'''
    return isinstance(a, IndexLike)

# %% ../nbs/02_grds.ipynb 25
#| export
